;
; STARFIELD
;

.686P											;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX												;; pour activer les instructions mmx
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED										;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP										;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE									;; optionel: rends les identifiants sensibles  la casse de caractres


;
; fichiers include
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc


;
; fichiers libraries
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib


;
; Prototypes
;

ProgrammePrincipal				PROTO
GestionnaireMessages			PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoiteDialogue	PROTO :DWORD,:DWORD,:DWORD,:DWORD


.CONST
;
; Constantes
;

Taille_Pile_Processus_Principal	EQU 16

Largeur_Ecran_Travail			EQU 800	;1024	;512
Hauteur_Ecran_Travail			EQU 600	;768	;384
Largeur_Ecran_Final				EQU 800	;1024	;512				;; ) ralentissement lorsque la taille diffre du bloc de travail, a cause du retaillage...
Hauteur_Ecran_Final				EQU 600	;768	;384				;; )
Largeur_Ecran_Travail_Moitiee		EQU Largeur_Ecran_Travail/2
Hauteur_Ecran_Travail_Moitiee		EQU Hauteur_Ecran_Travail/2

Vitesse_Deplacement_Minimale		EQU 2		;; 2 (sur 4096)
Vitesse_Acceleration			EQU 16
Vitesse_Deceleration			EQU 16
Vitesse_Deplacement_Maximale		EQU 128+Vitesse_Deplacement_Minimale	;; doit tre un multiple de Vitesse_Acceleration et Vitesse_Deceleration

Angle_Z_Minimal				EQU -128
Angle_Z_Maximal				EQU 128

Nombre_Etoiles					EQU 1024
Taille_Structure_Etoile			EQU 32
Couleur_Jaune					EQU 000DFDF3Fh			;; 223,223,063


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT						;; pour un total de 16 octets
	_Instance_			DWORD ?					;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?					;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?					;; taille maximale (dfinie par HeapCreate)
	_Variable_Temporaire_	DWORD ?					;; utilis, pour le moment...
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT								;; pour un total de 16 octets
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (align sur 16 octets)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Taille_Du_Bloc_		DWORD ?					;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Variable_Temporaire_	DWORD ?					;; utilis, pour le moment...
_Bloc_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire spcifique aux crans
_Bloc_Memoire_Ecran_	STRUCT						;; pour un total de 32 octets
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (align sur 16 octets)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Taille_Du_Bloc_		DWORD ?					;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Variable_Temporaire_	DWORD ?					;; inutilis, pour le moment...
	_Largeur_Ecran_		DWORD ?					;; largeur de l'cran (en pixels)
	_Hauteur_Ecran_		DWORD ?					;; hauteur de l'cran (en pixels)
	_Largeur_Ecran_X4_		DWORD ?					;; largeur de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	_Hauteur_Ecran_X4_		DWORD ?					;; hauteur de l'cran relle multiplie par 4 (*DWORD) (ici, c'est parfois utilis)
_Bloc_Memoire_Ecran_	ENDS

; cette structure n'est prsente qu'a titre d'information (puisque j'utilise registre+offset)
_Structure_Etoile_	STRUCT							;; pour un total de 64 octets
	_X_3D_			DWORD ?						;; offset 0, position 3D x
	_Y_3D_			DWORD ?						;; offset 4, position 3D y
	_Z_3D_			DWORD ?						;; offset 8, position 3D z
	_inutilise_		DWORD ?						;; offset 12, inutilis pour le moment...
	_X_2D_			DWORD ?						;; offset 16, position 2D x
	_Y_2D_			DWORD ?						;; offset 20, position 2D y
	_Ancien_X_2D_		DWORD ?						;; offset 24, ancienne position 2D x (pour un effet de mouvement/traine)
	_Ancien_Y_2D_		DWORD ?						;; offset 28, ancienne position 2D y (pour un effet de mouvement/traine)
_Structure_Etoile_	ENDS


.DATA
;
; Variable dfinies
;
INCLUDE TableSinusCosinus12bits.inc
INCLUDE Police_Xx20.inc


ALIGN 16
; quelques compteurs
Compteur_Boucle_Etoies			DWORD 0
Compteur_Des_images				DWORD 0


; variables diverses
Instance_Application			DWORD ?
Instance_Boites_De_Dialogue		DWORD ?
Pointeur_Ligne_De_Commande		DWORD 0
Pointeur_Fenetre				DWORD ?
Pointeur_DC_Ecran				HDC ?
Pointeur_Processus_Principal		DWORD ?

Vitesse_Deplacement				DWORD Vitesse_Deplacement_Minimale			; la vitesse par dfaut de dplacement dans notre starfield


;
; variables 3D
;
Angle_X			DWORD ?							;;	) angles de rotation
Angle_Y			DWORD ?							;;	)
Angle_Z			DWORD ?							;;	) par dfaut, pas de rotation
Sinus_X			DWORD ?							;; ) Sinus temporaires
Sinus_Y			DWORD ?							;; )
Sinus_Z			DWORD ?							;; )
Cosinus_X			DWORD ?							;;	) Cosinus temporaires
Cosinus_Y			DWORD ?							;;	)
Cosinus_Z			DWORD ?							;;	)


;
; variables 2D (lignes, points, ...)
;
Position_Ecran_X		DWORD ?
Position_Ecran_Y		DWORD ?
Mouvement_Souris_X		DWORD 0
Mouvement_Souris_Y		DWORD 0
Couleur_Etoile			DWORD 0


;
; quelques tmoins
;
Temoin_Afficher_Trainee			BYTE 1				;; ici, on place Vrai
Temoin_Des_Statistiques			BYTE 1
Temoin_Effet_Fondu				BYTE 1
Temoin_Type_Fondu				BYTE 0
Temoin_Poursuite_Processus		BYTE 1				;; 0=termin, 1=actif
Temoin_Redimensionnement			BYTE ?				;; 0=pas de redimensionnement, 1=redimensionnement *2, 2=redimensionnement autre que *2
; variables permettant de connaitre  tout moment le statut des boutons de la souris
Temoin_Bouton_Souris_Gauche		BYTE ?
Temoin_Bouton_Souris_Milieu		BYTE ?
Temoin_Bouton_Souris_Droit		BYTE ?


; chaines de caractres
Chaine_Titre_Fenetre			BYTE "Starfield",0
Chaine_Type_Fenetre				BYTE "Type Personnalis",0
Chaine_Boite_De_Dialogue_Quitter	BYTE "DialogueQuitter",0
Chaine_Images_Seconde			BYTE "Nombre d'images par secondes : "
Chaine_Nombre_Images_Seconde		BYTE 12 DUP(0h)


ALIGN 16
; definition des variables structures
Instance_Memoire				_Informations_Memoire_ <?>
Tampon_Ecran_Travail			_Bloc_Memoire_Ecran_ <?>
Tampon_Ecran_Final				_Bloc_Memoire_Ecran_ <?>
Tampon_Table_De_Redimensionnement	_Bloc_Memoire_ <?>
Tampon_Etoiles					_Bloc_Memoire_ <?>
Informations_Fenetre			WNDCLASSEX <?>
Informations_Messages_OS			MSG <?>

Informations_Bitmap LABEL BITMAPINFO
	BITMAPINFOHEADER < \ ;
		 SIZEOF BITMAPINFOHEADER,\ ;biSize
		 Largeur_Ecran_Final,\ ;biWidth
		 -Hauteur_Ecran_Final,\ ;biHeight (ngatif, pour que la premire ligne soit celle du haut, et pas celle du bas)
		 1,\ ;biPlanes
		 32,\ ;biBitCount
		 BI_RGB,\ ;biCompression
		 0,\ ;biSizeImage
		 0,\ ;biXPelsPerMeter
		 0,\ ;biYPelsPerMeter
		 0,\ ;biClrUsed
		 0> ;biClrImportant


.CODE
;
; Macros
;



.CODE
;
; les procdures
;


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gnration de nombres alatoires
; *
; * note : ici je n'ai pas utilis les valeurs que j'utilise habituellement, parcequ'elles font partie de ma
; * signature (et vous ne voudriez pas vous retrouver avec un procs sur le dos, non ?) alors j'en ai mis d'autres
; * qui devrait fonctionner...
; * si ce n'est pas le cas changez les... le systme employ permet un grand ventail de possibilits
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Nombres_Aleatoires_		DWORD ?
.CODE
ALIGN 16
;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
; Rceptionne :
; rien
;
; Retourne:
; eax = nombre de tick depuis le dmarrage de l'ordi. (mais surtout, la variable _Nombres_Aleatoires_ est dfinie)
;
; syntaxe : InitialiserNombresAleatoires
;
InitialiserNombresAleatoires PROC
		invoke GetTickCount							;; obtenir les millisecondes depuis le dmarrage
		test eax,eax								;; tester si eax = 0 (si c'est possible ! si vous lancez ce programme 48 jours aprs le dmarrage de l'ordinateur, lol)
		jnz Label1								;; si diffrent aller Label 1
		mov eax,123456789							;; mettre un nombre quelconque (pour eviter une division ultrieure par 0, suivant le gnrateur utilis)
Label1:	mov _Nombres_Aleatoires_,eax					;; sauver le rsultat pour initialiser les nombres alatoires
	ret											;; retourner (sortir de la procdure)
InitialiserNombresAleatoires ENDP


ALIGN 16
;
; generer un nombre aleatoire 32-bits entre 0 et une valeur maximale (exclue)
;
; Rceptionne :
; ebx = la valeur maximale +1 (ne peut pas tre zro, doit imprativement tre suprieur  1 pour une valeur
; situe dans un rang, ou 1 pour gnrer une valeur alatoire 32 bits)
;
; Retourne :
; eax = nombre aleatoire entre 0 et la valeur maximale (exclue), ou un nombre alatoire 32 bits si ebx = 1
;
; syntaxe : GenererNombreAleatoire
;
GenererNombreAleatoire PROC
		push edx									;; empiler edx

		mov eax,987654321							;; placer 987654321 dans eax
		mul _Nombres_Aleatoires_						;; multiplier eax par l'alatoire prcedent
		bswap eax									;; inverser l'ordre des octets pour rendre la valeur plus alatoire
		xor eax,078787878h							;; et pratiquer une inversion de bits (ne peut tre fait avec 0h ou FFFFFFFFh)
		jnz Label1								;; si c'est diffrent de 0, aller Label1
		mov eax,123456789							;; sinon, placer 123456789 dans eax
Label1:	mov _Nombres_Aleatoires_,eax					;; sauvegarder le nouveau nombre alatoire pour la gnration du prochain
; ici, on teste si c'est le cas d'une valeur alatoire 32 bits 
		cmp ebx,1									;; comparer ebx  1
		je Label2									;; si c'est le cas, c'est une valeur alatoire 32 bits, alors aller Label2
; ici, on traite le cas d'une valeur comprise entre 0 et X-1
		mul ebx									;; multiplier ensuite le nombre alatoire par la valeur maximale
		mov eax,edx								;; et placer le dpassement en eax
Label2:
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
GenererNombreAleatoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'agrandissement * 2
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; agrandir un cran (en multipliant sa taille par 2, en remplissant tout ce qui est ncessaire) en version MMX
; l'cran originel doit tre multiple de 2 car les pixels sont, ici, traits par paires
; videment, les deux blocs mmoire doivent avoir les tailles correspondantes...
;
; Rceptionne :
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination
;
; retourne :
; rien
;
; syntaxe : Mmx_AgrandirX2
;
Mmx_AgrandirX2 PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran originel dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut de la zone originelle dans esi
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone de destination dans edi
		neg ebx									;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
Label0:	mov ecx,eax								;; placer LargeurEcranOriginelX8 dans ecx
		add edi,eax								;; ajouter LargeurEcranOriginelX8 au pointeur destination
		lea edx,[ecx+edi]							;; placer edi+_Largeur_Ecran_Originel_X8_ dans edx
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
Label1:	movq MM0,QWORD PTR [ecx+esi]					;; placer la valeur de l'cran originel en esi+ecx dans MM0
		movd DWORD PTR [2*ecx+edi],MM0				;; et la recopier dans edi+(ecx*2)
		movd DWORD PTR [2*ecx+edx],MM0				;; et la recopier dans edx+(ecx*2)
		movq QWORD PTR [2*ecx+edi+4],MM0				;; et la recopier dans edi+(ecx*2)+4 
		movq QWORD PTR [2*ecx+edx+4],MM0				;; et la recopier dans edx+(ecx*2)+4
		psrlq MM0,32								;; dcaler le qword de 32 bits  droite
		movd DWORD PTR [2*ecx+edi+12],MM0				;; et la recopier dans edi+(ecx*2)+12
		movd DWORD PTR [2*ecx+edx+12],MM0				;; et la recopier dans edx+(ecx*2)+12
		add ecx,8									;; augmenter ecx d'1 qword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
Label2:	add edi,eax								;; ajouter LargeurEcranOriginelX8 au pointeur destination (puisqu'un ajout  dja t fait)
		inc ebx									;; incrmener ebx d'une ligne
		jnz Label0								;; tant que ebx est diffrent de 0, aller Label0

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AgrandirX2 ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'effacement d'un bloc mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; effacer un bloc memoire (en le remplissant de 0)
; note : MM0 est modifi
;
; Rceptionne :
; eax = taille  ffacer en octets
; esi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffacerBlocMemoire
;
Mmx_EffacerBlocMemoire PROC
		push ecx									;; empiler ecx

; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label0:	movq QWORD PTR[esi+ecx],MM0					;; placer 0 en esi+ecx
		movq QWORD PTR[esi+ecx+8],MM0					;; placer 0 en esi+ecx+8
		movq QWORD PTR[esi+ecx+16],MM0				;; placer 0 en esi+ecx+16
		movq QWORD PTR[esi+ecx+24],MM0				;; placer 0 en esi+ecx+24
		movq QWORD PTR[esi+ecx+32],MM0				;; placer 0 en esi+ecx+32
		movq QWORD PTR[esi+ecx+40],MM0				;; placer 0 en esi+ecx+40
		movq QWORD PTR[esi+ecx+48],MM0				;; placer 0 en esi+ecx+48
		movq QWORD PTR[esi+ecx+56],MM0				;; placer 0 en esi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0
; ici on traite les owords
Label1:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label2:	movq QWORD PTR[esi+ecx],MM0					;; placer 0 en esi+ecx
		movq QWORD PTR[esi+ecx+8],MM0					;; placer 0 en esi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2
; ici on traite les dwords
Label3:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label4:	mov DWORD PTR [esi+ecx],0					;; placer 0 en esi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est diffrent de 0, aller Label4
; ici on traite les octets
Label5:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b		;; ne conserver que les bits octets en ecx
		jz Label7									;; si ecx est gal  0, aller Label7
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label6:	mov BYTE PTR [esi+ecx],0						;; placer 0 en esi+ecx
		inc ecx									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label6								;; tant que ecx est diffrent de 0, aller Label6
Label7:	sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)

		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_EffacerBlocMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * 4 routines d'effet fondu
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; crer un effet blur montant sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduAscendant
;
Mmx_EffetFonduAscendant PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push esi									;; empiler esi
		push edi									;; empiler edi

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)
; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM3,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM3
		movd MM2,DWORD PTR [esi]						;; placer le dword en esi dans MM2
		punpcklbw MM3,MM7							;; entrelacer les octets suprieurs de MM3 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7
; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add esi,eax								;; on ajoute le rsultat  esi
		mov edi,esi								;; copier esi dans edi
		add edi,eax								;; ajouter _Largeur_Ecran_X4_  edi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter
; ici, commence la boucle pour une ligne
Label2:	movd MM1,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM1
		movd MM0,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM0
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
; faire la somme des valeurs
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
; transfert de donnes pour eviter de les relire et de refaire des entrelacements
		movq MM3,MM2								;; on transfert MM2 dans MM3
		movq MM2,MM1								;; on transfert MM1 dans MM2
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		pop edi									;; dsempiler edi
		pop esi									;; dsempiler esi
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduAscendant ENDP


ALIGN 16
;
; crer un effet blur descendant sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduDescendant
;
Mmx_EffetFonduDescendant PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push esi									;; empiler esi
		push edi									;; empiler edi

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)
; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM3,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM3
		movd MM2,DWORD PTR [esi]						;; placer le dword en esi dans MM2
		punpcklbw MM3,MM7							;; entrelacer les octets infrieurs de MM3 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets infrieurs de MM2 et MM7
; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		mov edi,esi								;; copier esi dans edx
		add esi,eax								;; on ajoute le rsultat  esi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter
; ici, commence la boucle pou une ligne
Label2:	movd MM1,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM1
		movd MM0,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM0
		punpcklbw MM1,MM7							;; entrelacer les octets suprieurs de MM1 et MM7
		punpcklbw MM0,MM7							;; entrelacer les octets suprieurs de MM0 et MM7
; faire la somme des valeurs
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
; transfert de donnes pour eviter de les relire et de refaire des entrelacements
		movq MM3,MM2								;; on transfert MM2 dans MM3
		movq MM2,MM1								;; on transfert MM1 dans MM2
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		pop edi									;; dsempiler edi
		pop esi									;; dsempiler esi
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduDescendant ENDP


ALIGN 16
;
; crer un effet blur leger sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduLeger
;
Mmx_EffetFonduLeger PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push esi									;; empiler esi

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)
; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM1,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM1 (n'est effectu qu'une seule fois)
; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add esi,eax								;; et l'ajouter  esi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter
; ici, commence la boucle pour une ligne
Label2:	movd MM0,DWORD PTR [esi+ecx]					;; placer le dword en esi dans MM0
		movd MM2,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM2
; transformer les octets en words
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7
; faire la somme des valeurs, et diviser la sommes par le nombre de valeurs
;		paddw MM0,MM0								;; ajouter en parallle MM0  MM0 (ici, c'est pour pouvoir diviser par 4 ensuite)
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		movq MM1,MM0								;; transferer MM0 dans MM1 (ce qui vitera de le relire)
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne

		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		pop esi									;; dsempiler esi
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduLeger ENDP


ALIGN 16
;
; crer un effet blur statique sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduStatique
;
Mmx_EffetFonduStatique PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi
		push edi									;; empiler edi

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)
; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM1,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM1 (n'est effectu qu'une seule fois)
; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		mov edx,esi								;; copier esi dans edx
		add esi,eax								;; on ajoute le rsultat  esi
		mov edi,esi								;; copier esi dans edi
		add edi,eax								;; ajouter _Largeur_Ecran_X4_  edi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter
; ici, commence la boucle pour une ligne
Label2:	movd MM0,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM0
		movd MM2,DWORD PTR [edx+ecx]					;; placer le dword en esi dans MM2
		movd MM3,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM3
; transformer les octets en words
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7
		punpcklbw MM3,MM7							;; entrelacer les octets suprieurs de MM3 et MM7
; faire la somme des valeurs
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		movq MM1,MM0								;; transferer MM0 dans MM1 (ce qui vitera de le relire)
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		pop edi									;; dsempiler edi
		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduStatique ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gestion mmoire/crans (c'est relativement la mme chose...)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; allouer un cran (bloc mmoire)  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = largeur de l'cran (en pixels)
; ebx = hauteur de l'cran (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (ce sera le tampon de l'cran)
;
; retourne :
; rien, mais les variables x._Pointeur_, x._Pointeur_A_Liberer_, x._Taille_Du_Bloc_, x._Largeur_Ecran_, x.Hauteur_Ecran_,
; x._Largeur_Ecran_X4_ et x.Hauteur_Ecran_X4_ sont dfinies
;
; syntaxe : CreerEcran
;
CreerEcran PROC

		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,eax	;; placer eax dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,ebx	;; placer eax dans x._Hauteur_Ecran_
		shl eax,2											;; multiplier la largeur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax	;; placer eax dans x._Largeur_Ecran_X4_
		mul ebx											;; multiplier _Largeur_Ecran_X4_ par _Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		shl ebx,2											;; multiplier la hauteur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_X4_,ebx	;; placer ebx dans x._Hauteur_Ecran_X4_

		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_

	ret											;; retourner (sortir de la procdure)
CreerEcran ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien, mais les variables x._Instance_, x._Taille_Initiale_ et x._Taille_Maximale_ sont dfinies
;
; syntaxe : CreerInstanceMemoire
;
CreerInstanceMemoire PROC

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_	;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax	;; sauvegarde du pointeur de l'instance

	ret											;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = taille du bloc mmoire que l'on va crer (en octets)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; rien, mais les variables x._Pointeur_, x._Pointeur_A_Liberer_ et x._Taille_Du_Bloc_ sont dfinies
;
; syntaxe : AllouerBlocMemoire
;
AllouerBlocMemoire PROC

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h							;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_

	ret											;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; rien
;
; syntaxe : LibererBlocMemoire
;
LibererBlocMemoire PROC

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

	ret											;; retourner (sortir de la procdure)
LibererBlocMemoire ENDP


ALIGN 16
;
; librer un cran (bloc mmoire)
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_
;
; retourne :
; rien
;
; syntaxe : SupprimerEcran
;
SupprimerEcran PROC

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

	ret											;; retourner (sortir de la procdure)
SupprimerEcran ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerInstanceMemoire
;
SupprimerInstanceMemoire PROC

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_	;; librer l'instance mmoire

	ret											;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de redimensionnement (autre que *2)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Largeur_Ecran_			DWORD ?
_Hauteur_Ecran_			DWORD ?
_Largeur_Ecran_Originel_		DWORD ?
_Hauteur_Ecran_Originel_		DWORD ?
.CODE
ALIGN 16
;
; crer et dfinir une table, pour retailler (changer l'echelle, pour eviter des multiplications et
; divisions multiples pendant le redimensionnement)
; note : ne pas oublier de supprimer la table de redimensionnement prcdente (s'il y en a une)
; avant d'en crer une nouvelle (le cumul injustifi causera un crash)
; et videment, il faut s'assurer qu'une instance mmoire a t cre
;
; Rceptionne :
; eax = largeur de l'cran que l'on veut obtenir (en pixels) (la largeur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)
; ebx = hauteur de l'cran que l'on veut obtenir (en pixels) (la hauteur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)
; ecx = largeur de l'cran originel (en pixels)
; edx = hauteur de l'cran originel (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_ (parcequ'on en a besoin)
; edi = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
;
; Retourne :
; rien
;
; syntaxe : DefinirTableDeRedimensionnement
;
DefinirTableDeRedimensionnement PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde les entres, ca va reservir...
		mov _Largeur_Ecran_,eax						;; sauvegarder eax dans _Largeur_Ecran_
		mov _Hauteur_Ecran_,ebx						;; sauvegarder ebx dans _Hauteur_Ecran_
		mov _Largeur_Ecran_Originel_,ecx				;; sauvegarder ecx dans _Largeur_Ecran_Originel_
		mov _Hauteur_Ecran_Originel_,edx				;; sauvegarder edx dans _Hauteur_Ecran_Originel_
; puis on calcul la taille mmoire  allouer...
		shl eax,2									;; multiplier _Largeur_Ecran_ par 4 (1 dword)
		mul ebx									;; multiplier _Largeur_Ecran_*DWORD par _Hauteur_Ecran_
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
; on alloue l'espace mmoire (qui est en fait gal  la taille cran) pour la table ( ce sera la zone de substitution de valeur)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
; maintenant on va remplir chaque valeur de la premire ligne de notre table de substitution par la position relative dans l'cran originel
		mov esi,eax								;; copier _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans esi
		mov ebx,_Largeur_Ecran_						;; placer _Largeur_Ecran_ dans ebx
		xor ecx,ecx								;; effacer ecx
; ici, on calcule les valeurs de substitution de la largeur
Label1:	mov eax,ecx								;; copier ecx dans eax
		mul _Largeur_Ecran_Originel_					;; multiplier eax par _Largeur_Ecran_Originel_
		xor edx,edx								;; effacer edx (ncessaire pour la division qui suit)
		div ebx									;; diviser eax par _Largeur_Ecran_
		shl eax,2									;; multiplier le rsultat obtenu par 4 (parceque ca devra tre un dword)
		mov DWORD PTR [4*ecx+esi],eax					;; sauver le rsultat obtenu  l'adresse en _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_+(ecx*4)
		inc ecx									;; incrmenter le pas de boucle
		cmp ecx,ebx								;; comparer ecx  _Largeur_Ecran_
		jb Label1									;; tant que ecx est infrieur  _Largeur_Ecran_, aller Label1
; ici, la premire ligne est calcule, on va la recopier dans toutes les autres lignes
		shl ebx,2									;; multiplier ebx par 4
		mov edi,esi								;; recopier l'adresse en esi dans edi
		add edi,ebx								;; ajouter l'uivalent d'une ligne  edi
		mov eax,_Hauteur_Ecran_						;; placer _Hauteur_Ecran_ (le nombre de lignes) dans eax
		dec eax									;; enlever une ligne  eax (ben oui, on en a dja calcul une...)
		neg eax									;; inverser eax
; ici on traite les owords
Label2:	mov ecx,ebx								;; copier _Largeur_Ecran_ x4 dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label3:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR [edi+ecx],edx					;; placer le dword en edi+ecx
		mov edx,DWORD PTR [esi+ecx+4]					;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR [esi+ecx+8]					;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR [edi+ecx+8],edx					;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR [esi+ecx+12]				;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; placer le dword en edi+ecx+12
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; ici on traite les dwords
Label4:	mov ecx,ebx								;; copier _Largeur_Ecran_ x4 dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label6									;; si ecx est gal  0, aller Label6
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
Label5:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et le recopier en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label5								;; tant que ecx est sign, aller Label5
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label6:	sub esi,ebx								;; soustraire la ligne copie  esi (pour retrouver l'adresse originelle)
		inc eax									;; incrmenter eax
		jnz Label2								;; tant que eax est diffrent de 0, aller Label2
; ici, notre table est remplie de premires ligne, on initialise la boucle pour la hauteur
		xor ecx,ecx								;; mettre ecx  0
; ici, on calcule les valeurs de substitution de la hauteur
Label7:	mov eax,ecx								;; copier ecx dans eax
		mul _Hauteur_Ecran_Originel_					;; multiplier eax par _Hauteur_Ecran_Originel_
		xor edx,edx								;; effacer edx (ncessaire pour la division qui suit)
		div _Hauteur_Ecran_							;; diviser eax par _Hauteur_Ecran_
		mul _Largeur_Ecran_Originel_					;; multiplier le rsultat en eax par une largeur de ligne
		shl eax,2									;; on multiplie eax par 4 (comme ca on a multipli par Largeur de ligne x4)
; ici, la hauteur est dfinie, on l'ajoute sur toutes les valeurs de la ligne, on traite les owords
		mov edi,ebx								;; copier _Largeur_Ecran_ x4 dans edi
		and edi,11111111111111111111111111110000b		;; ne conserver que les bits owords en edi
		jz Label9									;; si edi est gal  0, aller Label9
		add esi,edi								;; on ajoute edi  esi
		neg edi									;; inverser edi
Label8:	add DWORD PTR [esi+edi],eax					;; placer le dword en esi+edi
		add DWORD PTR [esi+edi+4],eax					;; placer le dword en esi+edi+4
		add DWORD PTR [esi+edi+8],eax					;; placer le dword en esi+edi+8
		add DWORD PTR [esi+edi+12],eax				;; placer le dword en esi+edi+12
		add edi,16								;; on ajoute 16  edi (notre pas de boucle)
		jnz Label8								;; tant que edi est diffrent de 0, aller Label8
; ici on traite les dwords
Label9:	mov edi,ebx								;; copier _Largeur_Ecran_ x4 dans edi
		and edi,00000000000000000000000000001100b		;; ne conserver que les bits dwords en edi
		jz Label11								;; si edi est gal  0, aller Label11
		add esi,edi								;; on ajoute edi  esi
		neg edi									;; inverser edi
Label10:	add DWORD PTR [esi+edi],eax					;; placer le dword en esi+edi
		add edi,4									;; on ajoute 4  edi (notre pas de boucle)
		jnz Label10								;; tant que edi est sign, aller Label10
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label11:	inc ecx									;; incrmenter le pas de boucle
		cmp ecx,_Hauteur_Ecran_						;; comparer ecx  _Hauteur_Ecran_
		jb Label7									;; tant que ecx est infrieur  _Hauteur_Ecran_, aller Label7

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DefinirTableDeRedimensionnement ENDP


ALIGN 16
;
; retailler un cran (en fait on va substituer des valeurs  d'autres, pour eviter des multiplications et divisions multiples)
; videment, une table doit, au pralable, avoir t dfinie par DefinirTableDeRedimensionnement
;
; Rceptionne :
; eax = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
; esi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran originel)
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran final)
;
;
; Retourne :
; rien
;
; syntaxe : Redimensionner
;
Redimensionner PROC
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov ebx,(_Bloc_Memoire_ PTR [eax])._Pointeur_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans ebx
; ici, on traite les owords
		mov ecx,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label2									;; si ecx est gal  0, aller Label2
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
Label1:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		mov edx,DWORD PTR [ebx+ecx+4]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; et la recopier dans edi+ecx+4
		mov edx,DWORD PTR [ebx+ecx+8]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+8],edx					;; et la recopier dans edi+ecx+8
		mov edx,DWORD PTR [ebx+ecx+12]				;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; et la recopier dans edi+ecx+12
		add ecx,16								;; augmenter ecx d'1 oword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
; ici, on traite les dwords
Label2:	mov ecx,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
Label3:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		add ecx,4									;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; on ne traite pas les octets car il ne peut y avoir que des dwords (alpha,rouge,vert,bleu) au minimum
Label4:	sub edi,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; soustraire _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ au pointeur destination (pour retrouver l'adresse originelle)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
Redimensionner ENDP


ALIGN 16
;
; supprimer une table de retaillage
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
;
; Retourne :
; rien
;
; syntaxe : SupprimerTableDeRedimensionnement
;
SupprimerTableDeRedimensionnement PROC
	
		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

	ret											;; retourner (sortir de la procdure)
SupprimerTableDeRedimensionnement ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines graphiques 2D
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Ligne_Decalage_Y_					DWORD ?			;; le dcalage  pratiquer sur l'axe Y (doit tre align su 16 octets pour une question de vitesse)
_Ligne_Couleur_De_La_Ligne_			DWORD ?			;; couleur de la ligne
.CODE
ALIGN 16
;
; dessiner une ligne de X1,Y1  X2,Y2 (si une des valeur n'est pas valide, rien n'est fait)
;
; Rceptionne :
; eax = la coordonne X1 (position largeur en pixels) valeur automatiquement positive de 0  largeur-1
; ebx = la coordonne Y1 (position hauteur en pixels) valeur automatiquement positive de 0  hauteur-1
; ecx = la coordonne X2 (position largeur en pixels) valeur automatiquement positive de 0  largeur-1
; edx = la coordonne Y2 (position hauteur en pixels) valeur automatiquement positive de 0  hauteur-1
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran
; edi = la couleur de la ligne
;
; Retourne :
; rien
;
; syntaxe : DessinerLigne
;
DessinerLigne PROC
; ici, on teste si les points se situent bien dans l'cran, sinon on va vers l'algorithme plus lent (qui tient compte des dpassements)...
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X1  x._Largeur_Ecran_
		jae AlgoLent								;; si la coordonne X1 est suprieure ou gale  LargeurEcranVirtuel, aller AlgoLent
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X2  x._Largeur_Ecran_
		jae AlgoLent								;; si la coordonne X2 est suprieure ou gale  LargeurEcranVirtuel, aller AlgoLent
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y1  x._Hauteur_Ecran_
		jae AlgoLent								;; si la coordonne Y1 est suprieure ou gale  HauteurEcranVirtuel, aller AlgoLent
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jae AlgoLent								;; si la coordonne Y2 est suprieure ou gale  HauteurEcranVirtuel, aller AlgoLent
; l les 2 points sont bien situs dans l'cran,
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde la couleur (ce qui permettra d'utiliser le registre edi)
		mov _Ligne_Couleur_De_La_Ligne_,edi			;; sauvegarder la couleur dans _Ligne_Couleur_De_La_Ligne_
		cmp eax,ecx								;; comparer la coordonne X1  X2
		ja Label01								;; si X1 est suprieur  X2, aller Label01
; ici on n'change pas la position des points
		mov edi,eax								;; sauvegarder la coordonne X1 dans edi
		sub ecx,eax								;; enlever X1  X2
		sub edx,ebx								;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx					;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx								;; placer Y1 dans eax
		mov ebx,ecx								;; placer l'cart X (X2-X1) dans ebx
		jmp Label02								;; aller Label02
; ici on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label01:	mov edi,ecx								;; sauvegarder la coordonne X1 (en fait X2) dans edi
		sub eax,ecx								;; enlever X2  X1
		sub ebx,edx								;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx					;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax								;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx								;; placer Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label02:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx									;; multiplier Y1 par x._Largeur_Ecran_X4_
		lea edi,[4*edi+eax]							;; multiplier edi par 4 (pour transformer en dwords) et ajouter Y1 * x._Largeur_Ecran_X4_  edi
		add edi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; on ajoute  edi le pointeur de dbut du bloc mmoire (qui contient dsormais la position du point)
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,_Ligne_Decalage_Y_					;; placer _Ligne_Decalage_Y_ dans eax
		test eax,eax								;; fixer les flags de eax
		jns Label03								;; si eax n'est pas sign, aller Label03
		neg eax									;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx									;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label03:	mov _Ligne_Decalage_Y_,ecx					;; sauvegarder ecx dans _Ligne_Decalage_Y_
; ici, on dtermine laquelle des 2 boucles on va utiliser
		cmp eax,ebx								;; comparer eax  ebx
		ja Label07								;; si eax est suprieur, aller Label07
; ici, on traite le cas o la largeur est la plus importante
		mov edx,_Ligne_Couleur_De_La_Ligne_			;; placer la couleur dans edx
		mov esi,ebx								;; copier ebx (l'cart en largeur) dans esi
		test esi,esi								;; fixer les flags de esi
		jz Label06								;; si esi est gal  zro, aller Label06
		lea ecx,[4*ebx]							;; placer ebx*4 dans ecx, qui devient notre pas de boucle
		add edi,ecx								;; ajouter ecx  edi
		neg ecx									;; inverser ecx (qui devient notre pas de boucle)
		inc eax									;; incrmenter eax (ce qui donnera un meilleur rsultat visuel pour la ligne)
Label04:	mov DWORD PTR [edi+ecx],edx					;; placer la couleur  l'endroit dfini
		sub esi,eax								;; soustraire l'cart en hauteur  esi
		jns Label05								;; si c'est infrieur ou gal, aller Label05
		add esi,ebx								;; sinon, ajouter l'cart en largeur  esi
		add edi,_Ligne_Decalage_Y_					;; ajouter _Ligne_Decalage_Y_  edi
Label05:	add ecx,DWORD								;; augmenter ecx de DWORD
		jnz Label04								;; tant que ecx n'est pas gal  0, retourner Label04
Label06:	mov DWORD PTR [edi],edx						;; placer la couleur  l'endroit dfini
		jmp Sortie								;; sinon, aller Sortie
; ici, on traite le cas o la hauteur est la plus importante
Label07:	mov esi,eax								;; copier eax (l'cart en hauteur) dans esi
		imul _Ligne_Decalage_Y_						;; multiplier eax par _Ligne_Decalage_Y_ (sign car _Ligne_Decalage_Y_ peut tre ngatif)
		mov ecx,eax								;; placer eax dans ecx, qui va devenir notre pas de boucle
		mov eax,esi								;; replacer l'cart en hauteur dans eax
		mov edx,_Ligne_Couleur_De_La_Ligne_			;; placer la couleur dans edx
		test esi,esi								;; fixer les flags de esi
		jz Label10								;; si esi est gal  zro, aller Label10
		add edi,ecx								;; ajouter ecx  edi
		neg ecx									;; inverser ecx (qui devient notre pas de boucle)
		inc ebx									;; incrmenter ebx (ce qui donnera un meilleur rsultat visuel pour la ligne)
Label08:	mov DWORD PTR [edi+ecx],edx					;; placer la couleur  l'endroit dfini
		sub esi,ebx								;; soustraire l'cart en largeur  esi
		jns Label09								;; si c'est infrieur ou gal sign, aller Label09
		add esi,eax								;; sinon, ajouter l'cart en hauteur  esi
		add edi,DWORD								;; ajouter DWORD  edi
Label09:	add ecx,_Ligne_Decalage_Y_					;; augmenter ecx de _Ligne_Decalage_Y_
		jnz Label08								;; tant que ecx n'est pas gal  0, retourner Label08
Label10:	mov DWORD PTR [edi],edx						;; placer la couleur  l'endroit dfini
;		jmp Sortie								;; sinon, aller Sortie
Sortie:
; enfin, on restaure les registres...
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
AlgoLent:
;		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
;
; enfin, on restaure les registres...
;		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DessinerLigne ENDP


ALIGN 16
;
; dessiner un point (un pixel) dans un cran
;
; Rceptionne :
; eax = position X (en pixels) du point dans l'cran (de 0  Largeur-1)
; ebx = position Y (en pixels) du point dans l'cran (de 0  Hauteur-1)
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran
; edi = couleur du point  afficher
;
; Retourne :
; rien
;
; Syntaxe : DessinerPoint
;
DessinerPoint PROC
; ici, on teste si les coordonnes du point se situent bien dans l'cran, sinon on sort...
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X  x._Largeur_Ecran_
		jae Label1								;; si X est suprieure ou gale  la largeur cran, aller Label1
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y  x._Hauteur_Ecran_
		jae Label1								;; si Y est suprieure ou gale  la hauteur cran, aller Label1
; l, le point est bien situ dans l'cran
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx ( cause de la multiplication)
; on dfini l'adresse
		mov ecx,eax								;; on copie eax dans ecx
		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; on place x._Largeur_Ecran_X4_ dans eax
		mul ebx									;; on multiplie eax par le nombre de lignes
		shl ecx,2									;; on multiplie eax par 4 (pour transormer les pixels en dwords)
		add ecx,eax								;; on ajoute eax  ecx
		add ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; on ajoute ensuite le pointeur de la zone du bloc cran
; et on affiche le point
		mov DWORD PTR [ecx],edi						;; et on fini en plaant la couleur  l'endroit appropri
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
Label1:
	ret											;; retourner (sortir de la procdure)
DessinerPoint endp


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine de conversion valeur -> chaine de caractre dcimale
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le job)
; note : cette routine n'est pas de moi, je sais plus o je l'ai rcupre, mais si je me souviens bien,
; c'est une adaption d'un algo cr par pdixon/michealw (ou quelque chose comme c... au dbut, j'aimait pas
; trop le bidouillage qui faisait passer le +1 en eax dans le multiplicateur, mais aprs tout, si ca fait le job,
; pourquoi pas...)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;
; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineDecimale
;
ConvertirValeurEnChaineDecimale PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi

		mov ecx,eax								;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768							;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx									;; multiplier eax par 2814749768
		shr edx,16								;; dcaler edx de 16 bits  droite
		mov eax,100000								;; placer 100000 dans eax
		mov ebx,edx								;; copier edx dans ebx
		mul edx									;; multiplier edx par 100000
		sub ecx,eax								;; soustraire le rsultat en eax  ecx
		test ebx,ebx								;; fixer les flags de ebx
		mov edx,ebx								;; replacer ebx dans edx
		mov ebx,10								;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01								;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497								;; on remplace eax par 429497
		mul edx									;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02								;; s'il existe un dpassement, aller Label02
		mul ebx									;; multiplier eax par 10
		jc Label03								;; s'il existe un dpassement, aller Label03
		mul ebx									;; multiplier eax par 10
		jc Label04								;; s'il existe un dpassement, aller Label04
		mul ebx									;; multiplier eax par 10
		jc Label05								;; s'il existe un dpassement, aller Label05
		mul ebx									;; multiplier eax par 10
		jc Label06								;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07								;; s'il existe un dpassement, aller Label07
		mul ebx									;; multiplier eax par 10
		jc Label08								;; s'il existe un dpassement, aller Label08
		mul ebx									;; multiplier eax par 10
		jc Label09								;; s'il existe un dpassement, aller Label09
		mul ebx									;; multiplier eax par 10
		jc Label10								;; s'il existe un dpassement, aller Label10
		mul ebx									;; multiplier eax par 10
		jmp Label11								;; aller Label11
; maintenant on va calculer et copier chaque octets/caractres
Label02:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label03:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label04:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label05:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label06:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi

		mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)

		inc esi									;; ajouter 1 octet  l'adresse en esi
Label07:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label08:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label09:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label10:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label11:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mov BYTE PTR [esi+1],0						;; placer le 0 final  l'adresse en esi+1
		xor eax,eax								;; effacer eax

		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Position_Chaine_Sur_Ecran_			DWORD ?
_Position_Chaine_Traitee_Sur_Ecran_	DWORD ?
_Adresse_De_La_Police_				DWORD ?
_Adresse_Du_Caractere_A_Afficher_		DWORD ?
_Couleur_De_Fond_De_La_Police_		DWORD 000000000h	;; ) blanc sur noir par dfaut
_Couleur_De_La_Police_				DWORD 000FFFFFFh	;; )
_Largeur_Ligne_Ecran_X4_Chaine_		DWORD ?
_Largeur_X4_Du_Caratere_Traite_		DWORD ?
.CODE
ALIGN 16
;
; Afficher une chane de caractres (largeur maximale des caractres de la police = 32 pixels, (ce qui est suffisant
; dans la plupart des cas...)) sans s'occuper du fond
;
; Rceptionne :
; eax = position X (largeur en pixels) de dpart
; ebx = position Y (hauteur en pixels) de dpart
; edx = adresse de la police de caratres  utiliser
; esi = adresse de la chaine  afficher
; edi = adresse (offset) de la structure cran
;
; Retourne :
; rien, mais la chaine est affiche  l'cran
;
; Syntaxe : AfficherChaineSansFond
;
AfficherChaineSansFond PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov _Adresse_De_La_Police_,edx				;; sauvegarder l'adresse de la police
		mov _Adresse_Du_Caractere_A_Afficher_,esi		;; sauvegarder l'adresse du caractre  afficher
; calculer la position de dpart
		shl eax,2									;; multiplier la position X par 4
		mov ecx,eax								;; sauvegarder eax dans ecx
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans eax
		mov _Largeur_Ligne_Ecran_X4_Chaine_,eax			;; sauvegarder la largeur dans la variable _Largeur_Ligne_Ecran_X4_Chaine_ (comme ca, pas besoin de repasser par la structure cran pour r-obtenir l'info)
		mul ebx									;; multiplier la largeur d'une ligne par la position Y
		add eax,ecx								;; ajouter la position X au rsultat obtenu
		add eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; ajouter l'adresse de dpart de l'cran  eax
		mov _Position_Chaine_Sur_Ecran_,eax			;; et sauvegarder le tout dans la variable _Position_Chaine_Sur_Ecran_
		mov _Position_Chaine_Traitee_Sur_Ecran_,eax		;; ainsi que dans la copie que l'on utilisera
; on teste si c'est la fin de chane
Label01:	mov esi,_Adresse_De_La_Police_				;; placer l'adresse de la police de caractres dans esi
		mov edi,_Adresse_Du_Caractere_A_Afficher_		;; placer l'adresse du caractre  afficher dans edi
		movzx eax,BYTE PTR [edi]						;; placer le caractre  afficher dans eax
		test eax,eax								;; fixer les flags de eax
		jz Label08								;; si eax est gal  zro (fin de chane), aller Label08 (la sortie)
; sinon,
		cmp eax,32								;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label07								;; si c'est infrieur  32, aller Label07
		mov ebx,DWORD PTR [esi]						;; et lire la hauteur des caractres
		shl ebx,2									;; multiplier ebx par 4 (puisque, ici, on lit des dwords)
; ici, ebx = hauteur du caractre *4 (hop, on ne touche plus a ebx, du moins jusqu'au prochain caractre...)
		cmp eax,DWORD PTR [esi+4]					;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02								;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127								;; sinon, placer 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32								;; enlever les 32 caractres "non affichables"  eax
; on calcule l'emplacement des donnes du caractre  afficher
		mov ecx,ebx								;; placer la hauteur des caractres dans ecx
		add ecx,4									;; ajouter le dword correspondant  la largeur du caractre
		mul ecx									;; multiplier le caractre par la "hauteur" des caractres
		add esi,eax								;; ajouter le rsultat obtenu  l'adresse de dpart de la police
; on calcul le complment d'une ligne (largeur d'une ligne - largeur du caractre)
		mov eax,DWORD PTR [esi+8]					;; placer la largeur du caractre dans eax (+8,  pour le dword de la hauteur, et le dword du caractre maxi)
		add esi,ebx								;; ajouter la hauteur * 4
; ici, esi = adresse des donnes du caractre
		neg ebx									;; inverser ebx pour notre boucle
		shl eax,2									;; multiplier la largeur par 4 (puisqu'on crit des dwords)
		sub eax,4									;; (a cause du 0 pour les adresses)
		mov _Largeur_X4_Du_Caratere_Traite_,eax			;; sauvegarder la largeur du caractre *4 en cours de traitement
; on dfini l'adresse/position dans l'cran et la couleur que l'on va utiliser
		mov edi,_Position_Chaine_Traitee_Sur_Ecran_		;; placer la position  crire dans edi
		mov eax,_Couleur_De_La_Police_				;; lire la couleur de la police
; boucle pour la hauteur
Label03:	mov ecx,_Largeur_X4_Du_Caratere_Traite_			;; placer la largeur du caractre *4 dans ecx
		mov edx,DWORD PTR [esi+ebx+12]				;; placer le dword  l'adresse en esi+ebx+4 dans edx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
; boucle pour la largeur
Label04:	shr edx,1									;; tester les bits "de 0  largeur"
		jnc Label05								;; si le flag carry n'est pas positionn, aller Label05
		mov DWORD PTR [edi+ecx],eax					;; placer la couleur de la police  l'adresse en esi
Label05:	sub ecx,4									;; enlever 1 (pixel)  ecx
		jns Label04								;; tant que ecx n'est pas ngatif, aller Label04
		add edi,_Largeur_Ligne_Ecran_X4_Chaine_			;; pour passer  la ligne de pixels suivante
		add ebx,4									;; enlever une ligne  ebx *4
		jnz Label03								;; tant que ebx n'est pas gal  zro, aller Label03
; sinon, on passe au caractre  afficher suivant
		mov eax,_Largeur_X4_Du_Caratere_Traite_			;; placer la largeur du caractre dans eax
		add eax,4									;; pour compenser le zro
		add _Position_Chaine_Traitee_Sur_Ecran_,eax		;; ajouter la largeur du caractre *4  l'adresse de la position
Label07:	inc _Adresse_Du_Caractere_A_Afficher_			;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01
Label08:
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
AfficherChaineSansFond ENDP


ALIGN 16
;
; dfinir les couleurs (caractres + fond) d'une chane de caractres
; note : ca peut paraitre stupide de crer une procdure avec seulement 2 instructions, mais ca permet d'eviter
; de rpeter cette opration systmatiquement dans AfficherChaine... (gain de vitesse), et c'est aussi quelque chose
; qui peut tre appel un nombre de fois considrable (donc, une macro prendrai beucoup plus d'espace mmoire)
;
; Rceptionne :
; eax = couleur de la police de caractres
; ebx = couleur de fond de la police de caractres
;
; Retourne :
; rien, mais les variables _Couleur_De_La_Police_ et _Couleur_De_Fond_De_La_Police_ qui servent pour AfficherChaine est dfinie
;
; Syntaxe : DefinirCouleursChaine
;
DefinirCouleursChaine PROC
		mov _Couleur_De_La_Police_,eax				;; sauvegarder la couleur de la police
		mov _Couleur_De_Fond_De_La_Police_,ebx			;; sauvegarder la couleur de fond de la police
	ret											;; retourner (sortir de la procdure)
DefinirCouleursChaine ENDP


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * ici, ce sont les procdures spcifiquement cres pour le starfield
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ALIGN 16
;
; gnrateur des pixels qui vont donner l'effet starfield
;
DessinerEtoiles PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

;
; dfinition de la vitesse de dplacement en fonction du statut de la souris
;
		cmp Temoin_Bouton_Souris_Droit,1				;; le bouton souris droit est press ?
		jne EviterIncrementerVitesseDeplacement			;; si ce n'est pas le cas, aller EviterIncrementerVitesseDeplacement
		cmp Vitesse_Deplacement,Vitesse_Deplacement_Maximale	;; comparer la vitesse de dplacement  Vitesse_Deplacement_Maximale
		je EviterIncrementerVitesseDeplacement			;; si c'est gal, aller EviterIncrementerVitesseDeplacement
		add Vitesse_Deplacement,Vitesse_Acceleration		;; sinon, augmenter la vitesse de dplacement
		jmp EviterDecrementerVitesseDeplacement			;; et aller EviterDecrementerVitesseDeplacement
EviterIncrementerVitesseDeplacement:
		cmp Vitesse_Deplacement,Vitesse_Deplacement_Minimale	;; comparer la vitesse de dplacement  Vitesse_Deplacement_Minimale
		je EviterDecrementerVitesseDeplacement			;; si c'est gal, aller EviterDecrementerVitesseDeplacement
		sub Vitesse_Deplacement,Vitesse_Deceleration		;; sinon, diminuer la vitesse de dplacement
EviterDecrementerVitesseDeplacement:


;
; obtenir le sinus et le Cosinus de x,y,z
;

; obtenir le sinus et le cosinus de x
		mov ebx,Angle_X							;; placer l'angle (utilis comme pointeur de 0  FFF) dans ebx
		and ebx,0FFFh								;; filtrer ebx pour ne conserver que les valeurs de 0  4095
		mov eax,[TableSinus+4*ebx]					;; obtenir le sinus de la table dans eax
		mov Sinus_X,eax							;; sauvegarder le rsultat obtenu dans Sinus_X
		mov eax,[TableCosinus+4*ebx]					;; obtenir le cosinus de la table dans eax
		mov Cosinus_X,eax							;; sauvegarder le rsultat obtenu dans Cosinus_X
; obtenir le sinus et le cosinus de y
		mov ebx,Angle_Y							;; placer l'angle (utilis comme pointeur de 0  FFF) dans ebx
		and ebx,0FFFh								;; filtrer ebx pour ne conserver que les valeurs de 0  4095
		mov eax,[TableSinus+4*ebx]					;; obtenir le sinus de la table dans eax
		mov Sinus_Y,eax							;; sauvegarder le rsultat obtenu dans Sinus_Y
		mov eax,[TableCosinus+4*ebx]					;; obtenir le cosinus de la table dans eax
		mov Cosinus_Y,eax							;; sauvegarder le rsultat obtenu dans Cosinus_Y
; obtenir le sinus et le cosinus de z
		mov ebx,Angle_Z							;; placer l'angle (utilis comme pointeur de 0  FFF) dans ebx
		and ebx,0FFFh								;; filtrer ebx pour ne conserver que les valeurs de 0  4095
		mov eax,[TableSinus+4*ebx]					;; obtenir le sinus de la table dans eax
		mov Sinus_Z,eax							;; sauvegarder le rsultat obtenu dans Sinus_Z
		mov eax,[TableCosinus+4*ebx]					;; obtenir le cosinus de la table dans eax
		mov Cosinus_Z,eax							;; sauvegarder le rsultat obtenu dans Cosinus_Z


;
; la boucle pour les toiles commence ici...
;
		mov eax,Nombre_Etoiles						;; ) dfinir au mieux notre compteur de boucle
		mov ebx,Taille_Structure_Etoile				;; )
		mul ebx									;; )
		sub eax,ebx								;; )
		mov Compteur_Boucle_Etoies,eax				;; )
BoucleNombreEtoiles:
		mov edi,Tampon_Etoiles._Pointeur_				;; placer le pointeur du tampon toiles dans esi
		add edi,Compteur_Boucle_Etoies				;; ajouter notre compteur de boucle  ce pointeur
		mov ecx,DWORD PTR [edi+8]					;; placer l'offset 8 (x._Z_3D_) dans ecx


;
; Verifier si l'toile est toujours valide, sinon on en cr une nouvelle :
; a ce stade, le pointeur de l'toile doit tre, et rester, dans edi
;
		cmp ecx,Vitesse_Deplacement					;; comparer la position restante (en x._Z_3D_)  la Vitesse_Deplacement
		jg FinVerificationValiditeEtoile				;; si ecx est suprieur, aller FinVerificationValiditeEtoile pour eviter la vrification
CreationNouvelleEtoile:
		mov ebx,Largeur_Ecran_Travail					;; ) gnrer un nombre alatoire pour la position cran x
		call GenererNombreAleatoire					;; )
		mov DWORD PTR [edi+16],eax					;; le placer  l'offset 16 (x._X_2D_)
		sub eax,Largeur_Ecran_Travail_Moitiee			;; soustraire la moitie de Largeur_Ecran_Travail  eax
		mov DWORD PTR [edi],eax						;; placer le rsultat  l'offset 0 (x._X_3D_)
		mov ebx,Hauteur_Ecran_Travail					;; ) gnrer un nombre alatoire pour la position cran y
		call GenererNombreAleatoire					;; )
		mov DWORD PTR [edi+20],eax					;; le placer  l'offset 20 (x._Y_2D_)
		sub eax,Hauteur_Ecran_Travail_Moitiee			;; soustraire la moitie de Hauteur_Ecran_Travail  eax
		mov DWORD PTR [edi+4],eax					;; placer le rsultat  l'offset 4 (x._Y_3D_)
		mov ecx,4096								;; placer 4096 (la profondeur)  l'offset 8 de la structure (temporairement ecx)
FinVerificationValiditeEtoile:


;
; remplacement des anciennes coordonnes 2D (pour l'effet traine)
;
		movq MM0,QWORD PTR [edi+16]					;; placer l'offset 16 (x._X_2D_) et l'offset 20 (x._Y_2D_) dans MM0
		movq QWORD PTR [edi+24],MM0					;; et le placer  l'offset 24 (x._Ancien_X_2D_) et l'offset 28 (x._Ancien_Y_2D_)


;
; Calcul des nouvelles coordonnes
; note : si on inverse les signes dans les 2 calculs, on inverse le sens de rotation
;
		sub ecx,Vitesse_Deplacement					;; soustraire Vitesse_Deplacement  l'offset 8 (Z3D)
		mov esi,DWORD PTR [edi]						;; placer l'offset 0 (x._X_3D_) dans esi
; obtenir le nouveau X => (nouveau X) = X * Cos(Angle_Z) - Y * Sin(Angle_Z) / 4096
		mov eax,DWORD PTR [edi+4]					;; placer l'offset 4 (x._Y_3D_)
		imul Sinus_Z								;; multiplier x._Y_3D_ par Sinus_Z, eax = Y*Sin(Angle_Z)
		mov ebx,eax								;; placer le rsultat obtenu dans ebx
		mov eax,esi								;; placer l'offset 4 (x._X_3D_) dans eax
		imul Cosinus_Z								;; multiplier x._X_3D_ par Cosinus_Z, eax = X*Cos(Angle_Z)
		sub eax,ebx								;; soustraire Y*Sin(Angle_Z)  X*Cos(Angle_Z)
		mov ebx,eax								;; sauvegarder le rsultat obtenu dans ebx
		sar ebx,12								;; diviser ebx par 4096 (maintenant, ebx est le nouveau X)
		mov DWORD PTR [edi],ebx						;; et on le place  l'offset 0 (x._X_3D_)
; transformation en coordonnees 2d
		cdq										;; propager le bit de signe en eax dans edx
		idiv ecx									;; division signe d'eax par l'offset 8 (x._Z_3D_)
		add eax,Largeur_Ecran_Travail_Moitiee			;; ajouter la moitie de la largeur cran  eax
		mov DWORD PTR [edi+16],eax					;; et placer le rsultat  l'offset 16 (x._X_2D_)
; obtenir le nouveau Y => (nouveau Y) = Y * Cos(Angle_Z) + X * Sin(Angle_Z) / 4096
		mov eax,esi								;; placer l'offset 4 (x._X_3D_)
		imul Sinus_Z								;; multiplier x._X_3D_ par Sinus_Z, eax = X*Sin(Angle_Z)
		mov ebx,eax								;; placer le rsultat obtenu dans ebx
		mov eax,DWORD PTR [edi+4]					;; placer l'offset 4 (x._Y_3D_) dans eax
		imul Cosinus_Z								;; multiplier x._Y_3D_ par Cosinus_Z, eax = Y*Cos(Angle_Z)
		add eax,ebx								;; ajouter X*Sin(Angle_Z)  Y*Cos(Angle_Z)
		mov ebx,eax								;; sauvegarder le rsultat obtenu dans ebx
		sar ebx,12								;; diviser ebx par 4096 (maintenant, ebx est le nouveau Y)
		mov DWORD PTR [edi+4],ebx					;; et on le place  l'offset 4 (x._Y_3D_)
; transformation en coordonnees 2d
		cdq										;; propager le bit de signe en eax dans edx
		idiv ecx									;; division signe d'eax par l'offset 8 (x._Z_3D_)
		add eax,Hauteur_Ecran_Travail_Moitiee			;; ajouter la moitie de la hauteur cran  eax
		mov DWORD PTR [edi+20],eax					;; et placer le rsultat  l'offset 20 (x._Y_2D_)
FinCalculNouvellesCoordonnees:


;
; dfinir la couleur de l'toile
;
		mov edx,ecx								;; copier ecx (x._Z_3D_) dans edx
		shr edx,4									;; dcaler edx  droite de 4 bits (pour passer de FFF  FF)
		neg edx									;; inverser la valeur
		add edx,0FFh								;; ajouter FF  cette valeur pour obtenir l'intensit de la couleur
		mov eax,000010101h							;; on place 010101h (les 3 composante de la couleur) dans eax
		mul edx									;; que l'on multipli par edx (l'intensit)
		or eax,00000007Fh							;; ici, c'est pour obtenir un petit effet bleut
		mov Couleur_Etoile,eax						;; et on sauvegarde la couleur obtenue


;
; Dessiner l'toile 
;
		mov DWORD PTR [edi+8],ecx					;; sauver ecx  l'offset 8 (x._Z_3D_)
		mov esi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse de la structure Tampon_Ecran_Travail
		cmp Temoin_Afficher_Trainee,1					;; comparer Temoin_Afficher_Trainee  1
		je DessinAvecTrainee						;; si c'est gal, aller DessinAvecTrainee
; dessiner un point X1,Y1 (on ne dfini que le registre pour la couleur, c'est le seul qui manque)
		mov eax,DWORD PTR [edi+16]					;; placer l'offset 16 (x._X_2D_) dans eax
		mov ebx,DWORD PTR [edi+20]					;; placer l'offset 20 (x._Y_2D_) dans eax
		mov edi,Couleur_Etoile						;; on place la couleur
		call DessinerPoint							;; et on dessine le point
		jmp EtoileDessinee							;; aller EtoileDessinee
DessinAvecTrainee:
; dessiner une ligne de X1,Y1  X2,Y2 (on ne dfini que le registre pour la couleur, c'est le seul qui manque)
		mov eax,DWORD PTR [edi+16]					;; placer l'offset 16 (x._X_2D_) dans eax
		mov ebx,DWORD PTR [edi+20]					;; placer l'offset 20 (x._Y_2D_) dans eax
		mov ecx,DWORD PTR [edi+24]					;; placer l'offset 24 (x._Ancien_X_2D_) dans eax
		mov edx,DWORD PTR [edi+28]					;; placer l'offset 28 (x._Ancien_Y_2D_) dans eax
		mov edi,Couleur_Etoile						;; on place la couleur
		call DessinerLigne							;; et on dessine la ligne
EtoileDessinee:


;
; fin de la boucle
;
FinBoucleNombreEtoiles:
		sub Compteur_Boucle_Etoies,Taille_Structure_Etoile	;; dcrmenter notre compteur de boucle d'une structure toile
		jns BoucleNombreEtoiles						;; tant que ce n'est pas sign, aller BoucleNombreEtoiles


; dessiner une ligne rouge de X1,Y1  X2,Y2 (ben quoi ? je peut tester mes routines quand mme... non ?)
		mov eax,0									;; placer X1=0
		mov ebx,0									;; placer Y1=0
		mov ecx,Largeur_Ecran_Travail-1				;; placer X2=799 ) -1  cause du 0 (799 + le 0 =800)
		mov edx,Hauteur_Ecran_Travail-1				;; placer Y2=599 )
		mov edi,000FF0000h							;; on place la couleur
		call DessinerLigne							;; et on dessine la ligne


;
; afficher le nombre d'images par secondes
;
		cmp Temoin_Des_Statistiques,0					;; on compare Temoin_Des_Statistiques  0
		je FinAffichageChaines						;; si c'est gal (rien  afficher), aller FinAffichageChaines
; ici on dfini la couleur par dfaut des textes  afficher dans l'cran (fait hors boucle, pour une question de vitesse)
		mov eax,Couleur_Jaune						;; ) dfinir les couleurs police + fond
;		mov ebx,Couleur_Rouge						;; ) (inutile si sans fond)
		call DefinirCouleursChaine					;; )
; ici on affiche la chaine
		xor eax,eax								;; position X (en pixels)
		xor ebx,ebx								;; position Y (en pixels)
		mov edx,OFFSET Police_Xx20					;; adresse de la police utilise
		mov esi,OFFSET Chaine_Images_Seconde			;; adresse de la chane  afficher
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse du Tampon_Ecran_Travail dans edi
		call AfficherChaineSansFond					;; afficher cette chane  la position spcifie
FinAffichageChaines:

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DessinerEtoiles endp


ALIGN 16
;
; procdure d'valuation du temps coul (sert pour les images secondes)
;
EvaluationTemps PROC HWndc:DWORD,uMsg2:DWORD,Periode_Ecoulee:DWORD,dwtime:DWORD

		cmp Periode_Ecoulee,1						;; comparer evnement priodique  1
		jne Label01								;; si c'est diffrent, aller Label01
		pushad									;; sinon, empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov eax,Compteur_Des_images					;; placer le Compteur_Des_images (nombre d'images obtenues) dans eax
		mov esi,OFFSET Chaine_Nombre_Images_Seconde		;; placer l'adresse qui doit contenir la chane du nombre dans esi
		call ConvertirValeurEnChaineDecimale			;; et convertir la valeur en chane dcimale
		mov Compteur_Des_images,0					;; effacer Compteur_Des_images
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label01:
	ret											;; retourner (sortir de la procdure)
EvaluationTemps ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Processus principal -> le starfield
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ProcessusPrincipal PROC

;
; dbut de la boucle qui sera le processus
;
DebutBoucleProcessus:


;
; on regarde si on doit appliquer l'effet blur (fondu)
;
		cmp Temoin_Effet_Fondu,1						;; l'effet blur est activ ?
		je AppliquerEffetFondu						;; si c'est le cas, aller AppliquerEffetFondu
; s'il n'y a pas d'effet  appliquer, on efface le tampon rserv pour l'cran
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; ) effacer l'cran (le remplir avec la couleur noire)
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; )
		call Mmx_EffacerBlocMemoire					;; )
; et on dessine les toiles
		call DessinerEtoiles						;; dessin des toiles
		jmp FinEffetFondu							;; et eviter l'effet fondu, aller FinEffetFondu
AppliquerEffetFondu:
; on dessine les toiles
		call DessinerEtoiles						;; dessin des toiles
; ici, on applique l'effet blur appropri
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) lire le type
		cmp Temoin_Type_Fondu,0						;; )
		je FonduLeger								;; )
		cmp Temoin_Type_Fondu,1						;; )
		je FonduStatique							;; )
		cmp Temoin_Type_Fondu,2						;; )
		je FonduDescendant							;; )
		call Mmx_EffetFonduAscendant					;; ) et application de l'effet
		jmp FinEffetFondu							;; )
FonduDescendant:									;; )
		call Mmx_EffetFonduDescendant					;; )
		jmp FinEffetFondu							;; )
FonduStatique:										;; )
		call Mmx_EffetFonduStatique					;; )
		jmp FinEffetFondu							;; )
FonduLeger:										;; )
		call Mmx_EffetFonduLeger						;; )
FinEffetFondu:										;; )


;
; redimenssionner l'cran (uniquement si ca doit tre fait)
;
		cmp Temoin_Redimensionnement,2				;; est-ce un redimensionnement autre que *2 ?
		je Redimensionnement						;; si c'est le cas, aller Redimensionnement
		cmp Temoin_Redimensionnement,1				;; est-ce un redimensionnement *2 ?
		je Redimensionnement2						;; si c'est le cas, aller Redimensionnement2
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,Tampon_Ecran_Travail._Largeur_Ecran_,Tampon_Ecran_Travail._Hauteur_Ecran_,NULL,NULL,NULL,Tampon_Ecran_Travail._Hauteur_Ecran_,Tampon_Ecran_Travail._Pointeur_,ADDR Informations_Bitmap,DIB_RGB_COLORS
		jmp FinRedimensionnement						;; aller FinRedimensionnement
Redimensionnement:
		mov eax,OFFSET Tampon_Table_De_Redimensionnement	;; ) redimensionnement vers l'cran final
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; )
		mov edi,Tampon_Ecran_Final._Pointeur_			;; )
		call Redimensionner							;; )
		jmp Redimensionnement3						;; aller Redimensionnement3
Redimensionnement2:
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) redimensionnement vers l'cran final en *2
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call Mmx_AgrandirX2							;; )
Redimensionnement3:
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,Tampon_Ecran_Final._Largeur_Ecran_,Tampon_Ecran_Final._Hauteur_Ecran_,NULL,NULL,NULL,Tampon_Ecran_Final._Hauteur_Ecran_,Tampon_Ecran_Final._Pointeur_,ADDR Informations_Bitmap,DIB_RGB_COLORS
FinRedimensionnement:


;
; fin de la boucle
;
		inc Compteur_Des_images						;; une image de plus  t faite, on incrmente donc notre compteur
		cmp Temoin_Poursuite_Processus,0				;; comparer Temoin_Poursuite_Processus  0
		jne DebutBoucleProcessus						;; tant que Temoin_Poursuite_Processus est diffrent de 0, aller DebutBoucleProcessus


;
; terminer le processus
;
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_BELOW_NORMAL	;; baisser la priorit du processus... THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		mov Temoin_Poursuite_Processus,-1				;; processus dfinitivement clos
		invoke InvalidateRect,Pointeur_Fenetre,NULL,1	;; invalider la zone client, pour viter qu'elle reste affiche
		invoke TerminateThread,Pointeur_Processus_Principal,0	;; terminer le processus
	ret											;; retourner (sortir de la procdure)
ProcessusPrincipal ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Starfield:

;
; la procdure principale (la seule qui ne ncessite pas un ret  la sortie)
;
ProgrammePrincipal PROC
;		invoke GetCurrentProcess						;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS	;; )
		invoke GetCommandLine						;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_De_Commande,eax				;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_De_Commande
		invoke GetModuleHandle,NULL					;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax					;; ) et sauvegarder le pointeur obtenu dans Instance_Application
		mov Informations_Fenetre.hInstance,eax			;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL					;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boites_De_Dialogue,eax			;;	) et sauvegarder le pointeur obtenu dans Instance_Boites_De_Dialogue
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
		mov esi,OFFSET Instance_Memoire				;; ) obtenir une instance mmoire
		call CreerInstanceMemoire					;; )
		call InitialiserNombresAleatoires				;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.


;
; centrer la position de notre cran (pour le cas o celui-ci est infrieur  l'cran OS)
;
		invoke GetSystemMetrics,SM_CXSCREEN			;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,Largeur_Ecran_Final					;; soustraire la largeur de notre ecran final
		sar eax,1									;; diviser ensuite ce resultat par 2
		mov Position_Ecran_X,eax						;; et placer le rsultat dans Position_Ecran_X
		invoke GetSystemMetrics,SM_CYSCREEN			;; obtenir la taille y de l'ecran os (toujours en pixels)
		sub eax,Hauteur_Ecran_Final					;; soustraire la hauteur de notre cran final
		sar eax,1									;; diviser ensuite ce resultat par 2
		mov Position_Ecran_Y,eax						;; et placer le rsultat dans Position_Ecran_Y


;
; remplir la structure WNDCLASSEX avec les variables requises, et cration de l'cran
;
		invoke LoadIcon,Instance_Application,500		;; pointeur sur l'icone (500 = ID de l'icne)
		mov Informations_Fenetre.hIcon,eax				;; sauver le pointeur
		invoke LoadCursor,NULL,IDC_ARROW
		mov Informations_Fenetre.hCursor,eax
; remplir le reste de la structure WNDCLASSEX avec les variables requises
		mov Informations_Fenetre.cbSize,SIZEOF WNDCLASSEX
		mov Informations_Fenetre.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE
		mov Informations_Fenetre.lpfnWndProc,OFFSET GestionnaireMessages
		mov Informations_Fenetre.cbClsExtra,NULL
		mov Informations_Fenetre.cbWndExtra,NULL
		mov Informations_Fenetre.hbrBackground,COLOR_BACKGROUND
		mov Informations_Fenetre.lpszMenuName,NULL
		mov Informations_Fenetre.lpszClassName,OFFSET Chaine_Type_Fenetre
		mov Informations_Fenetre.hIconSm,0
		invoke RegisterClassEx,ADDR Informations_Fenetre
; maintenant que tous les parametres sont dfinis, on cr l'cran
		invoke CreateWindowEx,WS_EX_LEFT,ADDR Chaine_Type_Fenetre,ADDR Chaine_Titre_Fenetre,WS_POPUP,Position_Ecran_X,Position_Ecran_Y,Largeur_Ecran_Final,Hauteur_Ecran_Final,NULL,NULL,Instance_Application,NULL
		mov Pointeur_Fenetre,eax


;
; on cr un pointeur pour le device context
;
		invoke GetDC,Pointeur_Fenetre
		mov Pointeur_DC_Ecran,eax


;
; ici, on alloue les blocs mmoires ncessaires
;
		mov eax,Nombre_Etoiles*Taille_Structure_Etoile	;; ) allouer un espace mmoire pour notre tampon concernant les toiles
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Etoiles					;; )
		call AllouerBlocMemoire						;; )
		mov eax,Largeur_Ecran_Travail					;;	) allouer un espace mmoire pour notre tampon ecran travail
		mov ebx,Hauteur_Ecran_Travail+2				;;	) ici on ajoute 2 (une ligne au dessus et une ligne en dessous)
		mov esi,OFFSET Instance_Memoire				;;	)
		mov edi,OFFSET Tampon_Ecran_Travail			;;	)
		call CreerEcran							;;	)
; suite  l'ajout des 2 lignes, il faut corriger quelques variables lies  la structure _Bloc_Memoire_Ecran_
		mov eax,Tampon_Ecran_Travail._Pointeur_			;; ) ici on ajoute une ligne (un dcalage ncessaire pour les effets blur)
		add eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; )
		mov Tampon_Ecran_Travail._Pointeur_,eax			;; )
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	) ici on enleve les 2 lignes qu'on avait rajout pour avoir une hauteur valide
		sub eax,2									;;	)
		mov Tampon_Ecran_Travail._Hauteur_Ecran_,eax		;;	)
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; placer la taille  effacer dans eax
		sub eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; ) enlever les 2 lignes (a cause des 2 lignes ajoutes) (c'est ncessaire pour eviter un crash en sortie d'app)
		sub eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; )
		mov Tampon_Ecran_Travail._Taille_Du_Bloc_,eax	;; )
; tester s'il y a un redimenssionnement  effectuer
		cmp Tampon_Ecran_Travail._Largeur_Ecran_,Largeur_Ecran_Final	;; comparer la largeur  celle de l'cran final
		jne DefinirTemoinRedimensionnement				;; si il y a une diffrence, aller DefinirTemoinRedimensionnement
		cmp Tampon_Ecran_Travail._Hauteur_Ecran_,Hauteur_Ecran_Final	;; comparer la hauteur  celle de l'cran final
		jne DefinirTemoinRedimensionnement				;; si il y a une diffrence, aller DefinirTemoinRedimensionnement
		mov Temoin_Redimensionnement,0				;; sinon, c'est qu'il n'y a pas de redimensionnement  faire
		jmp FinDefinirTemoinRedimensionnement			;; aller FinDefinirTemoinRedimensionnement
DefinirTemoinRedimensionnement:
		mov eax,Largeur_Ecran_Final					;; ) allouer un espace mmoire pour notre tampon ecran final
		mov ebx,Hauteur_Ecran_Final					;; )
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call CreerEcran							;; )
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; placer la largeur de l'ecran travail dans eax
		shl eax,1									;; multiplier cette largeur par 2
		cmp eax,Tampon_Ecran_Final._Largeur_Ecran_		;; on compare le rsultat  la largeur de l'cran final
		jne DefinirTemoinRedimensionnement2			;; si c'est diffrent, aller DefinirTemoinRedimensionnement2
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_		;; placer la hauteur de l'ecran travail dans eax
		shl eax,1									;; multiplier cette hauteur par 2
		cmp eax,Tampon_Ecran_Final._Hauteur_Ecran_		;; on compare le rsultat  la hauteur de l'cran final
		jne DefinirTemoinRedimensionnement2			;; si c'est diffrent, aller DefinirTemoinRedimensionnement2
		mov Temoin_Redimensionnement,1				;; sinon, il y aura un redimensionnement *2
		jmp FinDefinirTemoinRedimensionnement			;; aller FinDefinirTemoinRedimensionnement
DefinirTemoinRedimensionnement2:
		mov eax,Tampon_Ecran_Final._Largeur_Ecran_		;; ) dfinir la table de redimensionnement (la mmoire est alloue avec)
		mov ebx,Tampon_Ecran_Final._Hauteur_Ecran_		;; )
		mov ecx,Tampon_Ecran_Travail._Largeur_Ecran_		;; )
		mov edx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Table_De_Redimensionnement	;; )
		call DefinirTableDeRedimensionnement			;; )
		mov Temoin_Redimensionnement,2				;; il y aura un redimensionnement autre que *2
FinDefinirTemoinRedimensionnement:


;
; initialiser une profondeur pour le champ
;
		xor ecx,ecx								;; effacer ecx (mettre la boucle  zro)
InitialisationProfondeur:
		mov eax,Taille_Structure_Etoile				;; placer la taille d'une structure toile dans eax
		mul ecx									;; et multiplier eax par ecx (la valeur de boucle)
		add eax,Tampon_Etoiles._Pointeur_				;; ajouter le pointeur du tampon toiles  eax
		mov edi,eax								;; sauvegarder le pointeur de l'toile en cours pour la boucle dans edi
		mov ebx,4096								;; ) gnrer un nombre alatoire pour la position z
		call GenererNombreAleatoire					;; )
		mov DWORD PTR [edi+8],eax					;; le placer  l'offset 12 (x._Z_3D_)
		inc ecx									;; incrmenter d'un puisque c'est la fin de la boucle
		cmp ecx,Nombre_Etoiles						;; comparer le compteur en ecx  Nombre_Etoiles
		jb InitialisationProfondeur					;; si c'est infrieur, aller InitialisationProfondeur


;
; dfinir et lancer le processus principal
;
		invoke CreateThread,NULL,Taille_Pile_Processus_Principal*1024,ADDR ProcessusPrincipal,Pointeur_Fenetre,NULL,ADDR Pointeur_Processus_Principal
		mov Pointeur_Processus_Principal,eax				;; sauvegarder le pointeur obtenu
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; laisser la priorit du processus  la normale THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		mov Temoin_Poursuite_Processus,1				;; le processus est maintenant actif

		invoke ShowWindow,Pointeur_Fenetre,SW_SHOWNORMAL
		invoke UpdateWindow,Pointeur_Fenetre
		invoke SetTimer,Pointeur_Fenetre,1,1000,OFFSET EvaluationTemps


;
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
;
BoucleMessages:
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL
		cmp eax,NULL
		je FinBoucleMessages
		invoke TranslateMessage,ADDR Informations_Messages_OS
		invoke DispatchMessage,ADDR Informations_Messages_OS
		jmp BoucleMessages
FinBoucleMessages:


;
; librer les espaces mmoire
;
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure instance mmoire dans esi
		cmp Temoin_Redimensionnement,0				;; on teste s'il y a eu un redimensionnement
		je LibererMemoireEcrans2						;; s'il n'y a pas de redimensionnement, aller LibererMemoireEcrans2
		cmp Temoin_Redimensionnement,1				;; on teste s'il y a eu un redimensionnement *2
		je LibererMemoireEcrans						;; s'il n'y a pas de redimensionnement, aller LibererMemoireEcrans
		mov edi,OFFSET Tampon_Table_De_Redimensionnement	;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call SupprimerTableDeRedimensionnement			;; )
LibererMemoireEcrans:
		mov edi,OFFSET Tampon_Ecran_Final				;; ) supprimer l'espace mmoire pour l'ecran final
		call SupprimerEcran							;; )
LibererMemoireEcrans2:
		mov edi,OFFSET Tampon_Ecran_Travail			;; ) supprimer l'espace mmoire pour l'ecran travail
		call SupprimerEcran							;; )
		mov edi,OFFSET Tampon_Etoiles					;;	) supprimer l'espace mmoire pour notre tampon toiles
		call LibererBlocMemoire						;;	)
		call SupprimerInstanceMemoire					;; ) supprimer l'intance mmoire

		invoke ReleaseDC,Pointeur_Fenetre,Pointeur_DC_Ecran	;; librer le device context
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
;		invoke GetCurrentProcess						;;	) remettre la priorit du programme  la normale
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS	;;	)
		invoke ExitProcess,Informations_Messages_OS.wParam	;; sortie de l'application
ProgrammePrincipal ENDP


ALIGN 16
;
; ici, on inclus l'indispensable procdure de gestion des messages entre l'application et windows...
;
GestionnaireMessages PROC HWndGM:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

		cmp Temoin_Poursuite_Processus,-1				;; le processus est arrt ?
		jne GMPasFinApplication						;; si ce n'est pas le cas, aller GMPasFinApplication
		invoke UpdateWindow,Pointeur_Fenetre
		invoke PostQuitMessage,NULL					;; sinon, poster le message de sortie
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMPasFinApplication:
		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

; initialisation de la fentre
;		cmp eax,WM_CREATE
;		jne GMFinInitialisation						;; sinon, aller GMFinInitialisation
;
;	ret											;; retourner
;ALIGN 16
;GMFinInitialisation:

;; dessin de la fentre
;		cmp eax,WM_PAINT
;		jne GMFinMiseAJourEcran						;; sinon, aller GMFinMiseAJourEcran
;		invoke BeginPaint,HWndGM,ADDR DessinEcran
;
;		invoke EndPaint,HWndGM,ADDR DessinEcran
;	Retourner 0									;; retourner
;ALIGN 16
;GMFinMiseAJourEcran:

;;
;; fermeture de l'application ?
;;
;		cmp eax,WM_CLOSE							;; message de fermeture reu ?
;		jne GMFinFermeture							;; si ce n'est pas le cas, aller GMFinFermeture
;		mov Temoin_Poursuite_Processus,0				;; sinon, on place 0 dans Temoin_Poursuite_Processus
;		xor eax,eax								;; remettre eax  zro
;	ret											;; retourner
;ALIGN 16
;GMFinFermeture:

;
; fin du processus principal
;
		cmp eax,WM_DESTROY							;; fermeture de l'application par la croix ?
		jne GMFinProcessusTermine					;; si ce n'est pas le cas, aller GMFinProcessusTermine
		mov Temoin_Poursuite_Processus,0				;; sinon, on place 0 dans Temoin_Poursuite_Processus
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMFinProcessusTermine:
;
; les messages :
; WM_LBUTTONDOWN, WM_LBUTTONUP, WM_LBUTTONDBLCLK,
; WM_MBUTTONDOWN, WM_MBUTTONUP, WM_MBUTTONDBLCLK,
; WM_RBUTTONDOWN, WM_RBUTTONUP, WM_RBUTTONDBLCLK, WM_MOUSEMOVE
; retournent le rsultat obtenu par les boutons et le mouvement de la souris.
;
		cmp eax,WM_LBUTTONDOWN						;; bouton gauche de la souris press ?
		jne GMPasBoutonSourisGauche					;; si c'est diffrent, aller GMPasBoutonSourisGauche
		mov Temoin_Bouton_Souris_Gauche,1
	ret											;; retourner
ALIGN 16
GMPasBoutonSourisGauche:
;
		cmp eax,WM_LBUTTONUP						;; bouton gauche de la souris non press ?
		jne GMBoutonSourisGauche						;; si c'est diffrent, aller GMBoutonSourisGauche
		mov Temoin_Bouton_Souris_Gauche,0
	ret											;; retourner
ALIGN 16
GMBoutonSourisGauche:
;;
;		cmp eax,WM_LBUTTONDBLCLK						;; bouton gauche de la souris double clique ?
;		jne GMPasBoutonSourisGaucheDouble				;; si c'est diffrent, aller GMPasBoutonSourisGaucheDouble
;
;	ret											;; retourner
;ALIGN 16
;GMPasBoutonSourisGaucheDouble:
;
		cmp eax,WM_MBUTTONDOWN						;; bouton milieu de la souris press ?
		jne GMPasBoutonSourisMilieu					;; si c'est diffrent, aller GMPasBoutonSourisMilieu
		mov Temoin_Bouton_Souris_Milieu,1
	ret											;; retourner
ALIGN 16
GMPasBoutonSourisMilieu:
;
		cmp eax,WM_MBUTTONUP						;; bouton milieu de la souris non press ?
		jne GMBoutonSourisMilieu						;; si c'est diffrent, aller GMBoutonSourisMilieu
		mov Temoin_Bouton_Souris_Milieu,0
	ret											;; retourner
ALIGN 16
GMBoutonSourisMilieu:
;;
;		cmp eax,WM_MBUTTONDBLCLK						;; bouton milieu de la souris double clique ?
;		jne GMPasBoutonSourisMilieuDouble				;; si c'est diffrent, aller GMPasBoutonSourisMilieuDouble
;
;	ret											;; retourner
;ALIGN 16
;GMPasBoutonSourisMilieuDouble:
;
		cmp eax,WM_RBUTTONDOWN						;; bouton droit de la souris press ?
		jne GMPasBoutonSourisDroit					;; si c'est diffrent, aller GMPasBoutonSourisDroit
		mov Temoin_Bouton_Souris_Droit,1
	ret											;; retourner
ALIGN 16
GMPasBoutonSourisDroit:
;
		cmp eax,WM_RBUTTONUP						;; bouton droit de la souris non press ?
		jne GMBoutonSourisDroit						;; si c'est diffrent, aller GMBoutonSourisDroit
		mov Temoin_Bouton_Souris_Droit,0
	ret											;; retourner
ALIGN 16
GMBoutonSourisDroit:
;;
;		cmp eax,WM_RBUTTONDBLCLK						;; bouton droit de la souris double clique ?
;		jne GMPasBoutonSourisDroitDouble				;; si c'est diffrent, aller GMPasBoutonSourisDroitDouble
;
;	ret											;; retourner
;ALIGN 16
;GMPasBoutonSourisDroitDouble:

;;
;; mouvement de la souris ?
;;
;		cmp eax,WM_MOUSEMOVE						;; un mouvement de la souris ?
;		jne GMPasMouvementsSouris					;; si ce n'est pas le cas, aller GMPasMouvementsSouris
;; ici, on traite la rotation par rapport  l'axe Y (mouvement souris X)
;		mov eax,LParam								;; sinon on place LParam (Y (word), X (word)) dans eax
;		and eax,00000FFFFh							;; filtrer eax (pour avoir uniquement le X)
;		mov Mouvement_Souris_X,eax					;; sauvegarder le rsultat dans Mouvement_Souris_X (peut tre plac ici, puisque ca ne modifie pas les flags)
;; ici, on traite la rotation par rapport  l'axe X (mouvement souris Y)
;		mov eax,LParam								;; sinon on place LParam (Y (word), X (word)) dans eax
;		shr eax,16								;; dcaler eax  droite de 16 bits (pour avoir l'Y au bon endroit)
;		mov Mouvement_Souris_Y,eax					;; sauvegarder le rsultat dans Mouvement_Souris_Y (peut tre plac ici, puisque ca ne modifie pas les flags)
;;		mov eax,WParam								;; pas utile pour le moment...
;
;	ret											;; retourner
;ALIGN 16
;GMPasMouvementsSouris:
	

;
; ici, les messages concernant les touches prsses
;

; touche presse ?
		cmp eax,WM_KEYDOWN
		jne GMFinTouchePressee						;; sinon, aller GMFinTouchePressee
		mov eax,WParam

; Quitter ?
		cmp eax,VK_ESCAPE							;; Quitter ?
		jne GMPasToucheQuitter						;; sinon, aller GMPasToucheQuitter
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boites_De_Dialogue,ADDR Chaine_Boite_De_Dialogue_Quitter,0,ADDR GestionnaireMessagesBoiteDialogue,0
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
	ret											;; retourner
ALIGN 16
GMPasToucheQuitter:
;ALIGN 16
;; F1 ?
;		cmp eax,VK_F1
;		jne GMPasToucheF1Pressee						;; sinon, aller GMPasToucheF1Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF1Pressee:
;; F2 ?
;		cmp eax,VK_F2
;		jne GMPasToucheF2Pressee						;; sinon, aller GMPasToucheF2Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF2Pressee:
;; F3 ?
;		cmp eax,VK_F3
;		jne GMPasToucheF3Pressee						;; sinon, aller GMPasToucheF3Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF3Pressee:
;; F4 ?
;		cmp eax,VK_F4
;		jne GMPasToucheF4Pressee						;; sinon, aller GMPasToucheF4Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF4Pressee:
; F5 ?
		cmp eax,VK_F5
		jne GMPasToucheF5Pressee						;; sinon, aller GMPasToucheF5Pressee
		mov Temoin_Type_Fondu,0
	ret
ALIGN 16
GMPasToucheF5Pressee:
; F6 ?
		cmp eax,VK_F6
		jne GMPasToucheF6Pressee						;; sinon, aller GMPasToucheF6Pressee
		mov Temoin_Type_Fondu,1
	ret
ALIGN 16
GMPasToucheF6Pressee:
; F7 ?
		cmp eax,VK_F7
		jne GMPasToucheF7Pressee						;; sinon, aller GMPasToucheF7Pressee
		mov Temoin_Type_Fondu,2
	ret											;; retourner
ALIGN 16
GMPasToucheF7Pressee:
; F8 ?
		cmp eax,VK_F8
		jne GMPasToucheF8Pressee						;; sinon, aller GMPasToucheF8Pressee
		mov Temoin_Type_Fondu,3
	ret											;; retourner
ALIGN 16
GMPasToucheF8Pressee:
;; F9 ?
;		cmp eax,VK_F9
;		jne GMPasToucheF9Pressee						;; sinon, aller GMPasToucheF9Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF9Pressee:
;; F10 ?
;		cmp eax,VK_F10
;		jne GMPasToucheF10Pressee					;; sinon, aller GMPasToucheF10Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF10Pressee:
;; F11 ?
;		cmp eax,VK_F11
;		jne GMPasToucheF11Pressee					;; sinon, aller GMPasToucheF11Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF11Pressee:
;; F12 ?
;		cmp eax,VK_F12
;		jne GMPasToucheF12Pressee					;; sinon, aller GMPasToucheF12Pressee
;		not ModeAuto
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF12Pressee:
; haut ?
		cmp eax,VK_UP								;; touche haut ?
		jne GMPasToucheHaut							;; sinon eviter les lignes suivantes
		mov eax,Vitesse_Deplacement_Maximale			;; placer Vitesse_Deplacement_Maximale dans eax
		cmp eax,Vitesse_Deplacement					;; et la comparer  Vitesse_Deplacement
		je GMEviterIncrementerVitesseDeplacement		;; si c'est gal, aller GMEviterIncrementerVitesseDeplacement
		add Vitesse_Deplacement,Vitesse_Acceleration		;; incrmenter la Vitesse_Deplacement
GMEviterIncrementerVitesseDeplacement:
	ret											;; retourner
ALIGN 16
GMPasToucheHaut:
; bas ?
		cmp eax,VK_DOWN							;; touche bas ?
		jne GMPasToucheBas							;; sinon eviter les lignes suivantes
		mov eax,Vitesse_Deplacement_Minimale			;; placer Vitesse_Deplacement_Minimale dans eax
		cmp eax,Vitesse_Deplacement					;; et la comparer  Vitesse_Deplacement
		je GMEviterDecrementerVitesseDeplacement		;; si c'est gal, aller GMEviterDecrementerVitesseDeplacement
		sub Vitesse_Deplacement,Vitesse_Deceleration		;; dcrmenter la Vitesse_Deplacement
GMEviterDecrementerVitesseDeplacement:
	ret											;; retourner
ALIGN 16
GMPasToucheBas:
; droite ?
		cmp eax,VK_RIGHT							;; touche droite ?
		jne GMPasToucheDroite						;; sinon eviter les lignes suivantes
		mov eax,Angle_Z_Maximal						;; placer Angle_Z_Maximal dans eax
		cmp eax,Angle_Z							;; et la comparer  Angle_Z
		je GMEviterIncrementerRotation				;; si c'est gal, aller GMEviterIncrementerVitesse
		add Angle_Z,16								;; incrmenter Angle_Z
GMEviterIncrementerRotation:
	ret											;; retourner
ALIGN 16
GMPasToucheDroite:
; gauche ?
		cmp eax,VK_LEFT							;; touche gauche ?
		jne GMPasToucheGauche						;; sinon eviter les lignes suivantes
		mov eax,Angle_Z_Minimal						;; placer Angle_Z_Minimal dans eax
		cmp eax,Angle_Z							;; et la comparer  Angle_Z
		je GMEviterDecrementerRotation				;; si c'est gal, aller GMEviterDecrementerVitesse
		sub Angle_Z,16								;; dcrmenter Angle_Z
GMEviterDecrementerRotation:
	ret											;; retourner
ALIGN 16
GMPasToucheGauche:
; b ?
		cmp eax,VK_B
		jne GMPasToucheBPressee						;; sinon, aller GMPasToucheBPressee
		xor Temoin_Effet_Fondu,1
	ret											;; retourner
ALIGN 16
GMPasToucheBPressee:
; s ?
		cmp eax,VK_S
		jne GMPasToucheSPressee						;; sinon, aller GMPasToucheSPressee
		xor Temoin_Des_Statistiques,1
	ret											;; retourner
ALIGN 16
GMPasToucheSPressee:
; t ?
		cmp eax,VK_T								;; touche T ?
		jne GMPasToucheTPressee						;; sinon eviter les lignes suivantes
		xor Temoin_Afficher_Trainee,1
	ret											;; retourner
ALIGN 16
GMPasToucheTPressee:
;


	ret											;; retourner
ALIGN 16
GMFinTouchePressee:

;;
;; ici, les messages concernant les touches relaches
;;
;
;; touche relache ?
;		cmp eax,WM_KEYUP
;
;		jne GMFinToucheRelachee
;		mov eax,WParam
;
;; gauche ?
;		cmp eax,VK_LEFT
;		jne GMPasToucheGaucheRelachee					;; sinon, aller GMPasToucheGaucheRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheGaucheRelachee:
;; droite ?
;		cmp eax,VK_RIGHT
;		jne GMPasToucheDroiteRelachee					;; sinon, aller GMPasToucheDroiteRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheDroiteRelachee:
;; haut ?
;		cmp eax,VK_UP
;		jne GMPasToucheHautRelachee					;; sinon, aller GMPasToucheHautRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheHautRelachee:
;; bas ?
;		cmp eax,VK_DOWN
;		jne GMPasToucheBasRelachee					;; sinon, aller GMPasToucheBasRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheBasRelachee:
;
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheRelachee:


;
; on finit avec le traitement par dfaut
;
		invoke DefWindowProc,HWndGM,Message,WParam,LParam
	ret
GestionnaireMessages ENDP


ALIGN 16
;
; gestionnaire des messages par boites de dialogue
;
GestionnaireMessagesBoiteDialogue PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)


		cmp eax,WM_COMMAND
		jne GMBDFinCommandes
		mov eax,WParam								;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; boite de dialogue pour quitter le programme
;


;
; hum... oui
;
		cmp eax,1002								;; Hum... oui est cliqu ?
		jne GMBDPasHumOui							;; si c'est diffrent, aller GMBDPasHumOui
		mov Temoin_Poursuite_Processus,0				;; stoper le processus en cours
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMBDPasHumOui:


;
; Ah a non !
;
		cmp eax,1003								;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon							;; si c'est diffrent, aller GMBDPasAhCaNon
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
	ret											;; retourner
ALIGN 16
GMBDPasAhCaNon:


;
; traitement par dfaut pour les boites de dialogue
;
GMBDFinCommandes:
		xor eax,eax								;; effacer eax (ce sera le traitement par dfaut des messages)
	ret											;; retourner
GestionnaireMessagesBoiteDialogue ENDP




;
; fin du programme
;
END Starfield


